from bt.backtest.lstm.data_generate import (
    generate
)
from bt.backtest.lstm.data_retrieve import *
from bt.strategies.strategies import (
    SimpleEMAStrategy
)
import pytz
from datetime import datetime
from bt.backtest.common.datagen_helpers import (
    generateCSVTitle
)

#make a backtest data generator class?


def main():

    name = 'mac_tonight'
    dir = generateCSVTitle(name)
    #open(dir, 'w').close()

    start = datetime(2007, 1, 1, 0, 0, 0, 0, pytz.utc)
    td = 40
    principal = 1000.0
    frequency = 'daily'
    bundle = None
    asset = None

    ##add a sanity check so that the strategies, start date, and bundle match the frequency

    assets = ['AAPL', 'GIS', 'X', 'MSFT']#, 'WMT', 'INTC', 'AMD', 'AMZN', 'EBAY', 'GE', 'NVDA', 'MAT', 'RRC', 'UAA', 'APA', 'GS', 'JPM', 'HES', 'AMAT']
    #assets = ['GIS', 'X', 'MSFT', 'WMT', 'INTC']
    #assets = ['HES', 'AMAT']
    EMAStrategy = SimpleEMAStrategy(start, td, principal, frequency, bundle, asset)
    strategy = EMAStrategy
    indicators = ['EMA', 'LongEMA', 'RSI', 'PercentK', 'Momentum',
                  'CommoditiesChannelIndex', 'Disparity5']
    intervals = 70
    #intervals = 1
    #type = 'regression'
    type = 'classification'
    categories = 2
    generate(assets=assets, strategy=strategy, indicators=indicators, num_intervals=intervals,
             input_td=20, output_td=10, type=type, dir=dir, categories=categories, pooling=False, append=False)


if __name__ == "__main__":
    main()
