from string import Formatter

import requests
import os

import numpy as np
import pandas as pd
import datetime

import zipline




# lambda s: "./tsdata/{}".format(s))

# ref http://www.prokopyshen.com/create-custom-zipline-data-bundle
def viacsv(symbols, start=None, end=None,
           get_url=lambda
                   s: "https://www.alphavantage.co/query?function=TIME_SERIES_INTRADAY&symbol={}&interval=15min&outputsize=full&apikey=B3TV3X0DX3V9DNZ6&datatype=csv".format(
               s)):
    tuSymbols = tuple(symbols)

    def ingest(environ,
               asset_db_writer,
               minute_bar_writer,
               daily_bar_writer,
               adjustment_writer,
               calendar,
               start_session,
               end_session,
               cache,
               show_progress,
               output_dir):
        dfMetadata = pd.DataFrame(np.empty(len(tuSymbols), dtype=[
            ('start_date', 'datetime64[ns]'),
            ('end_date', 'datetime64[ns]'),
            ('auto_close_date', 'datetime64[ns]'),
            ('symbol', 'object'),
        ]))

        csv_list = []
        num_csv = 0
        for S in tuSymbols:
            dfData = pd.read_csv(get_url(S), index_col='timestamp', parse_dates=True).sort_index()

            dfData['volume'] = dfData['volume'] / 1000
            csv_list.append((num_csv, dfData))
            end_date = dfData.index[-1]

            dfMetadata.iloc[num_csv] = dfData.index[0], end_date, end_date + pd.Timedelta(minutes=1), S

            num_csv += 1

        minute_bar_writer.write(csv_list, show_progress=False)

        dfMetadata['exchange'] = "YAHOO"

        symbol_map = pd.Series(dfMetadata.symbol.index, dfMetadata.symbol)

        asset_db_writer.write(equities=dfMetadata)

        adjustment_writer.write()

    return ingest


if __name__ == '__main__':
    response = requests.get(
        "https://www.alphavantage.co/query?function=TIME_SERIES_INTRADAY&symbol=MSFT&interval=15min&outputsize=full&apikey=B3TV3X0DX3V9DNZ6&datatype=csv")
    csv = response.content
    lines = csv.splitlines()
    data = []
    for line in lines[1:]:
        entries = line.split(',')  # timestamp,open,high,low,close,volume
        data.append(
            (entries[0], float(entries[1]), float(entries[2]), float(entries[3]), float(entries[4]), int(entries[5])))

    print data
